package provide DS9 1.0

proc Block {value} {
    global block
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	$current(frame) block factor $value
	set block(factor) [$current(frame) get block factor]
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc BlockToFit {} {
    global current
    global block

    if {$current(frame) != ""} {
	SetWatchCursor
	$current(frame) block to fit
	set block(factor) [$current(frame) get block factor]
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc ChangeBlockFactor {} {
    global block
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	$current(frame) block factor to $block(factor)
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc ChangeBlockFunction {} {
    global block
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	$current(frame) block function $block(function)
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc ChangeBlockBufferSize {} {
    global block
    global current

    if {$current(frame) != ""} {
	SetWatchCursor
	$current(frame) block buffer size $block(buffersize)
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc BlockDialog {} {
    global current
    global blockD

    set w ".block"
    set blockD(ok) 0
    set blockD(factor) [$current(frame) get block factor fixed]
    set c [$current(frame) get block cursor fixed]
    set blockD(x) [lindex $c 0]
    set blockD(y) [lindex $c 1]

    DialogCreate $w "Change Block Factor" -borderwidth 2
    frame $w.factor  -relief groove -borderwidth 2
    frame $w.center  -relief groove -borderwidth 2
    frame $w.buttons -relief groove -borderwidth 2
    pack $w.factor $w.center $w.buttons -fill x -ipadx 4 -ipady 4

    label $w.factor.title -text "Block Factor"
    entry $w.factor.value -textvariable blockD(factor) \
	-width 9 -relief sunken -bd 2
    pack $w.factor.title $w.factor.value -side left -padx 4
    pack $w.factor.value -ipadx 2 -ipady 2

    label $w.center.title -text "Block Center"
    frame $w.center.value
    entry $w.center.value.x -textvariable blockD(x) -width 20 \
	-relief sunken -bd 2
    entry $w.center.value.y -textvariable blockD(y) -width 20 \
	-relief sunken -bd 2
    pack $w.center.value.x $w.center.value.y -side top -pady 2 \
	-ipadx 1 -ipady 1
    label $w.center.title2 -text "physical"
    pack $w.center.title $w.center.value $w.center.title2 \
	-side left -anchor nw -padx 4 -pady 4

    button $w.buttons.ok -text "OK" -default active -command {set blockD(ok) 1}
    button $w.buttons.apply -text "Apply" -command BlockDialogApply
    button $w.buttons.cancel -text "Cancel" -command {set blockD(ok) 0}
    pack $w.buttons.ok $w.buttons.apply $w.buttons.cancel \
	-side left -padx 10 -expand true

    bind $w <Return> {set blockD(ok) 1}
    bind $w <Alt-o> "tkButtonInvoke $w.buttons.ok"
    bind $w <Alt-c> "tkButtonInvoke $w.buttons.cancel"

    DialogCenter $w 
    $w.factor.value select range 0 end
    DialogWait $w blockD(ok) $w.factor.value
    DialogDismiss $w

    if {$blockD(ok)} {
	BlockDialogApply
    }

    # we want to destroy this window

    destroy $w 
}

proc BlockDialogApply {} {
    global current
    global block
    global blockD

    if {$current(frame) != ""} {
	set block(factor) $blockD(factor)
	if {$block(factor) < 1} {
	    set block(factor) 1
	}

	SetWatchCursor
	$current(frame) block factor to $block(factor) \
	    about $blockD(x) $blockD(y) physical
	UpdateContourMenu
	UpdateGraphXAxis
	UnsetWatchCursor
    }
}

proc UpdateBlockMenu {} {
    global current
    global block
    global buttons

    if {$current(frame) != ""} {
	if {[$current(frame) get fits count] > 0} {
	    if {[$current(frame) has block]} {

		set block(function) [$current(frame) get block function]
		set block(factor) [$current(frame) get block factor]	    
		set block(buffersize) [$current(frame) get block buffer size]

		.menuBar entryconfig "Block" -state normal
		$buttons(name).major.block configure -state normal
	    } else {
		.menuBar entryconfig "Block" -state disabled
		$buttons(name).major.block configure -state disabled
	    }
	} else {
	    .menuBar entryconfig "Block" -state normal
	    $buttons(name).major.block configure -state normal
	}
    } else {
	.menuBar entryconfig "Block" -state disabled
	$buttons(name).major.block configure -state disabled
    }
}

