package provide DS9 1.0

proc ClearPrefs {} {
    global prefs
    if {[tk_messageBox -type okcancel -default cancel \
	     -message "Clear Preferences?"] == "ok"} {
	catch {file delete -force $prefs(file)}
    }
}

proc LoadPrefs {} {
    global prefs

    catch {source $prefs(file)}

    # now fix any backward compatibility issues

    global wcs
    if {$wcs(format)=="hms"} {
	set wcs(format) sexagesimal
    }

    global coord
    if {$coord(format)=="hms"} {
	set coord(format) sexagesimal
    }

    global rectangle
    global box
    if {[info exists rectangle(width)]} {
	set box(width) $rectangle(width)
    }
    if {[info exists rectangle(height)]} {
	set box(height) $rectangle(height)
    }
}

proc SavePrefs {} {
    global prefs

    # open prefs file

    set file [open $prefs(file) w]
    if {$file == ""} {
	tk_messageBox -message \
	    "An Error as occured while saving preferences." \
	    -type ok -icon error
	return
    }

    # general prefs

    puts $file ""
    puts $file "\# general prefs"
    global info
    puts $file "global info"
    puts $file "set info(view) $info(view)"
    global pan
    puts $file "global pan"
    puts $file "set pan(view) $pan(view)"
    global mag
    puts $file "global mag"
    puts $file "set mag(view) $mag(view)"
    global buttons
    puts $file "global buttons"
    puts $file "set buttons(view) $buttons(view)"
    global colorbar
    puts $file "global colorbar"
    puts $file "set colorbar(view) $colorbar(view)"

    puts $file ""
    puts $file "\# Frame prefs"
    global canvas
    puts $file "global canvas"
    puts $file "set canvas(auto) $canvas(auto)"
    puts $file "set canvas(size) $canvas(size)"
    global tile
    puts $file "global tile"
    puts $file "set tile(mode) $tile(mode)"
    global blink
    puts $file "global blink"
    puts $file "set blink(interval) $blink(interval)"

    puts $file ""
    puts $file "\# Block prefs"
    global prefs
    puts $file "global prefs"
    global block
    puts $file "global block"
    puts $file "set prefs(blockfunction) $prefs(blockfunction)"
    puts $file "set block(function) $prefs(blockfunction)"
    puts $file "set prefs(blockfactor) $prefs(blockfactor)"
    puts $file "set block(factor) $prefs(blockfactor)"
    puts $file "set prefs(blockbuffersize) $prefs(blockbuffersize)"
    puts $file "set block(buffersize) $prefs(blockbuffersize)"

    puts $file ""
    puts $file "\# Zoom prefs"
    global prefs
    puts $file "global prefs"
    global current
    puts $file "global current"
    global wcs
    puts $file "global wcs"
    puts $file "set prefs(wcsalign) $prefs(wcsalign)"
    puts $file "set wcs(align) $prefs(wcsalign)"
    puts $file "set prefs(zoom) $prefs(zoom)"
    puts $file "set current(zoom) $prefs(zoom)"
    puts $file "set prefs(orient) $prefs(orient)"
    puts $file "set current(orient) $prefs(orient)"
    puts $file "set prefs(rotate) $prefs(rotate)"
    puts $file "set current(rotate) $prefs(rotate)"

    puts $file ""
    puts $file "\# Scale prefs"
    global prefs
    puts $file "global prefs"
    global current
    puts $file "global current"
    global scale
    puts $file "global scale"
    puts $file "set prefs(scale) $prefs(scale)"
    puts $file "set current(scale) $prefs(scale)"
    puts $file "set prefs(scalemode) $prefs(scalemode)"
    puts $file "set scale(mode) $prefs(scalemode)"

    puts $file ""
    puts $file "\# Color prefs"
    global prefs
    puts $file "global prefs"
    global colorbar
    puts $file "global colorbar"
    puts $file "set prefs(colorbarmap) $prefs(colorbarmap)"
    puts $file "set colorbar(map) $prefs(colorbarmap)"
    puts $file "set prefs(colorbarinvert) $prefs(colorbarinvert)"
    puts $file "set colorbar(invert) $prefs(colorbarinvert)"

    puts $file ""
    puts $file "\# Region prefs"
    global circle
    puts $file "global circle"
    puts $file "set circle(radius) $circle(radius)"
    global ellipse
    puts $file "global ellipse"
    puts $file "set ellipse(radius1) $ellipse(radius1)"
    puts $file "set ellipse(radius2) $ellipse(radius2)"
    global box
    puts $file "global box"
    puts $file "set box(width) $box(width)"
    puts $file "set box(height) $box(height)"

    puts $file ""
    puts $file "\# Analysis prefs"
    global graphHorz
    puts $file "global graphHorz"
    puts $file "set graphHorz(grid) $graphHorz(grid)"
    puts $file "set graphHorz(log) $graphHorz(log)"
    global graphVert
    puts $file "global graphVert"
    puts $file "set graphVert(grid) $graphVert(grid)"
    puts $file "set graphVert(log) $graphVert(log)"
    global dss
    puts $file "global dss"
    puts $file "set dss(server) $dss(server)"
    global nsvr
    puts $file "global nsvr"
    puts $file "set nsvr(server) $nsvr(server)"

    puts $file ""
    puts $file "\# Help prefs"
    global help
    puts $file "global help"
    puts $file "set help(ref) $help(ref)"
    puts $file "set help(user) $help(user)"

    puts $file ""
    puts $file "\# Infomation Panel prefs"
    global info
    puts $file "global info"
    puts $file "set info(filename) $info(filename)"
    puts $file "set info(object) $info(object)"
    puts $file "set info(minmax) $info(minmax)"
    puts $file "set info(wcs) $info(wcs)"
    puts $file "set info(detector) $info(detector)"
    puts $file "set info(amplifier) $info(amplifier)"
    puts $file "set info(physical) $info(physical)"
    puts $file "set info(image) $info(image)"
    puts $file "set info(frame) $info(frame)"

    puts $file ""
    puts $file "\# WCS Menu prefs"
    global wcs
    puts $file "global wcs"
    puts $file "set wcs(system) $wcs(system)"
    puts $file "set wcs(format) $wcs(format)"

    puts $file ""
    puts $file "\# Panner prefs"
    global pan
    puts $file "global pan"
    puts $file "set pan(imagecompass) $pan(imagecompass)"
    puts $file "set pan(wcscompass) $pan(wcscompass)"
    puts $file "set pan(wcstanpoint) $pan(wcstanpoint)"

    puts $file ""
    puts $file "\# Magnifier prefs"
    global mag
    puts $file "global mag"
    puts $file "set mag(mode) $mag(mode)"
    puts $file "set mag(region) $mag(region)"
    puts $file "set mag(cursor) $mag(cursor)"
    puts $file "set mag(zoom) $mag(zoom)"

    puts $file ""
    puts $file "\# Dialog prefs"
    global ds9
    puts $file "global ds9"
    puts $file "set ds9(dialog) $ds9(dialog)"

    puts $file ""
    puts $file "\# Pan prefs"
    global pan
    puts $file "global pan"
    puts $file "set pan(mode) $pan(mode)"

    puts $file ""
    puts $file "\# Display Coords prefs"
    global coord
    puts $file "global coord"
    puts $file "set coord(fk4) $coord(fk4)"
    puts $file "set coord(fk5) $coord(fk5)"
    puts $file "set coord(icrs) $coord(icrs)"
    puts $file "set coord(galactic) $coord(galactic)"
    puts $file "set coord(ecliptic) $coord(ecliptic)"
    puts $file "set coord(linear) $coord(linear)"
    puts $file "set coord(detector) $coord(detector)"
    puts $file "set coord(amplifier) $coord(amplifier)"
    puts $file "set coord(physical) $coord(physical)"
    puts $file "set coord(image) $coord(image)"
    puts $file "set coord(format) $coord(format)"
    puts $file "set coord(value) $coord(value)"

    puts $file ""
    puts $file "\# Examine prefs"
    global examine
    puts $file "global examine"
    puts $file "set examine(mode) $examine(mode)"
    puts $file "set examine(zoom) $examine(zoom)"

    puts $file ""
    puts $file "\# URL prefs"
    global http
    global ftp
    puts $file "global http"
    puts $file "global ftp"
    puts $file "set http(log) $http(log)"
    puts $file "set ftp(log) $ftp(log)"

    puts $file ""
    puts $file "\# Misc prefs"
    global ds9
    puts $file "global ds9"
    puts $file "set ds9(cursor) $ds9(cursor)"
    puts $file "set ds9(scanOnLoad) $ds9(scanOnLoad)"

    # and close

    close $file
}
