package provide DS9 1.0

proc TextDialog {frame id} {
    # see if we already have a header window visible

    set w ".marker$id"
    set mb ".mb$id"

    if [winfo exist $w] {
	return
    }

    # Init common items

    InitMarkerDialog $frame $id
    PropMenuTextDialog $frame $mb $id
    CoordMenuMarkerDialog $frame $mb $id MoveMarkerCB

    # Text specific callbacks

    $frame marker $id callback delete DeleteTextDialog $frame

    # Dialog

    CommonMarkerDialog $frame $id
    wm protocol $w WM_DELETE_WINDOW "CloseTextDialog $frame $id"

    # Buttons

    button $w.buttons.apply -text "Apply" \
	-command "ApplyTextDialog $frame $id"
    button $w.buttons.close -text "Close" \
	-command "CloseTextDialog $frame $id"
    pack $w.buttons.apply $w.buttons.close -side left -padx 10 -expand true

    bind $w <Return> "ApplyTextDialog $frame $id"
}

proc PropMenuTextDialog {frame mb id} {
    global menu
    global marker

    menu $mb.properties -tearoff 0 -selectcolor $menu(selectcolor)
    $mb.properties add checkbutton -label "Can Move" \
	-variable marker($frame,$id,move) \
	-command "PropertyMarkerDialog $frame $id move"
    $mb.properties add checkbutton -label "Can Delete" \
	-variable marker($frame,$id,delete) \
	-command "PropertyMarkerDialog $frame $id delete"
}

proc ApplyTextDialog {frame id} {
    ApplyMarkerDialog $frame $id
}

# dialog is closed, marker still exist

proc CloseTextDialog {frame id} {
    $frame marker $id delete callback delete DeleteTextDialog
    DeleteMarkerCBs $frame $id

    DeleteMarkerDialog $frame $id
}

# marker is being deleted, just close dialog

proc DeleteTextDialog {frame id} {
    DeleteMarkerDialog $frame $id
}

proc TextInitDialog {} {
}
