#ifndef __fitsshare_h__
#define __fitsshare_h__

#include "map.h"

class FitsShareID : public virtual FitsMap {
public:
  FitsShareID(int, int, const char*);
  virtual ~FitsShareID();
};

class FitsShareKey : public virtual FitsMap {
public:
  FitsShareKey(int, int, const char*);
  virtual ~FitsShareKey();
};

class FitsFitsShare : public virtual FitsMap {
 public:
  FitsFitsShare(ScanMode);
};

class FitsArrShare : public virtual FitsMap {
 public:
  FitsArrShare();
};

class FitsMosaicShare : public virtual FitsMap {
 public:
  FitsMosaicShare();
};

class FitsFitsShareID : public FitsShareID, public FitsFitsShare {
public:
  FitsFitsShareID(int, int, const char*, ScanMode);
};

class FitsFitsShareKey : public FitsShareKey, public FitsFitsShare {
public:
  FitsFitsShareKey(int, int, const char*, ScanMode);
};

class FitsArrShareID : public FitsShareID, public FitsArrShare {
public:
  FitsArrShareID(int, int, const char*);
};

class FitsArrShareKey : public FitsShareKey, public FitsArrShare {
public:
  FitsArrShareKey(int, int, const char*);
};

class FitsMosaicShareID : public FitsShareID, public FitsMosaicShare {
public:
  FitsMosaicShareID(int, int);
};

class FitsMosaicShareKey : public FitsShareKey, public FitsMosaicShare {
public:
  FitsMosaicShareKey(int, int);
};

#endif
