#ifndef __annuli_h__
#define __annuli_h__

#include <iostream.h>
#include <strstream.h>
#include <tk.h>

#include "marker.h"

#define MAXANNULI 20

class AnnuliMarker : public Marker {
protected:
  int segments;
  int annuli;
  double ratio[MAXANNULI];
  Vector** vertices;

protected:
  virtual void updateHandles() {}
  virtual void calcPoints(double) {}
  double maxAnnuli();

private:
  void render(Drawable drawable, const Matrix& matrix, GC, double);
  void newVertices();
  void deleteVertices();

public:
  AnnuliMarker(Frame*, const Vector&, int, const char*,  const char*, 
	       const char*, unsigned short);
  virtual ~AnnuliMarker() {}

  virtual void updateBBox();
  virtual void updateCoords(Matrix&) {}
  virtual void draw();
  virtual void drawXOR();
  virtual void drawMagnifier(const Matrix&);
  virtual void ps(int);

  void addAnnuli(double);
};

#endif
