#ifndef __box_h__
#define __box_h__

#include "annuli.h"

class Box : public AnnuliMarker {
private:
  Vector size;
  double angle;
  Matrix flip;

  void calcPoints(double);
  void updateHandles();

public:
  Box(Frame* p, const Vector& ctr, const Vector& s, double a,
      const char* clr,  const char* f, const char* t, unsigned short prop);

  void updateCoords(Matrix&);
  void editBegin(int);
  void edit(const Vector&, int);
  void editEnd();
  void rotate(const Vector&, int);
  int isIn(const Vector&);

  Vector getSize() {return size.abs();}
  double getAngle() {return angle;}
  void setSize(const Vector&);
  void setAngle(double);

  void list(ostream&, int, int);
  void listSAOtng(ostream&, int, int);
  void listSAOimage(ostream&);
  void listPros(ostream&, int, int);
};

#endif
