#ifndef __contour_h__
#define __contour_h__

#include "vector.h"
#include "list.h"
#include "contourscale.h"
#include "frame.h"

class FitsImage;

class ContourPlot {
 protected:
  Frame* parent;
  List<Vertex>* contours;

  char* colorName;
  int color;

 public:
  ContourPlot(Frame*, const char*);
  ContourPlot(Frame*, const char*, List<Vertex>*);
  virtual ~ContourPlot();

  void render(Pixmap, const Matrix&, const BBox&);
  void ps(Frame::PSColorSpace);
  List<Vertex>* dup();
  List<Vertex>* getContours() {return contours;}
};

#endif




