#ifndef __ellipse_h__
#define __ellipse_h__

#include "annuli.h"

class Ellipse : public AnnuliMarker {
private:
  Vector radius;
  double angle;
  Matrix flip;            // non iis needs a flip in Y

  void calcPoints(double);
  void updateHandles();

public:
  Ellipse(Frame* p, const Vector& ctr, const Vector& r, double a, 
	  const char* clr,  const char* f, const char* t, unsigned short prop);

  void updateCoords(Matrix&);
  void edit(const Vector&, int);
  void rotate(const Vector&, int);
  int isIn(const Vector&);

  const Vector& getRadius() {return radius;}
  double getAngle() {return angle;}
  void setRadius(const Vector&);
  void setAngle(double);

  void list(ostream&, int, int);
  void listSAOtng(ostream&, int, int);
  void listSAOimage(ostream&);
  void listPros(ostream&, int, int);
};

#endif


