%option noyywrap
%option caseless
%option never-interactive
%option c++

%{
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>

  #include "util.h"
  #include "parser.C.h"

  extern frFlexLexer* frlexx;
%}

%x PASSTHRU

D   [0-9]
E   [Ee][+-]?{D}+

/* rules */

%%

<PASSTHRU>.*	{  // grab the rest of the line
		  BEGIN INITIAL;
		  strcpy(frlval.str,yytext);
		  return STRING;
		}

about		{return ABOUT_;}
accurate	{return ACCURATE_;}
alloc		{return ALLOC_;}
align		{return ALIGN_;}
all		{return ALL_;}
amplifier	{return AMPLIFIER_;}
angle		{return ANGLE_;}
arcmin		{return ARCMIN_;}
arcsec		{return ARCSEC_;}
array		{return ARRAY_;}
arrow		{return ARROW_;}
automatic	{return AUTOMATIC_;}
average		{return AVERAGE_;}
b1950		{return B1950_;}
back		{return BACK_;}
bbox		{return BBOX_;}
begin		{return BEGIN_;}
block		{return BLOCK_;}
box		{return BOX_;}
boxcircle	{return BOXCIRCLE_;}
buffer		{return BUFFER_;}
bw		{return BW_;}
callback	{return CALLBACK_;}
canvas		{return CANVAS_;}
center		{return CENTER_;}
channel		{return CHANNEL_;}
circle		{return CIRCLE_;}
clear		{return CLEAR_;}
clip		{return CLIP_;}
colormap	{return COLORMAP_;}
color		{return COLOR_;}
colors          {return COLORS_;}
colorscale	{return COLORSCALE_;}
colorspace	{return COLORSPACE_;}
command		{return COMMAND_;}
contour		{return CONTOUR_;}
coordinates	{return COORDINATES_;}
copy            {return COPY_;}
count		{return COUNT_;}
cross		{return CROSS_;}
cursor		{return CURSOR_;}
create		{return CREATE_;}
crosshair	{return CROSSHAIR_;}
cut		{return CUT_;}
cmyk		{return CMYK_;}
datamin		{return DATAMIN_;}
debug		{return DEBUG_;}
degrees		{return DEGREES_;}
default		{return DEFAULT_;}
delete		{return DELETE_;}
detector	{return DETECTOR_;}
diamond		{return DIAMOND_;}
distance	{return DISTANCE_;}
ds9		{return DS9_;}
ecliptic	{return ECLIPTIC_;}
ellipse		{return ELLIPSE_;}
edit		{return EDIT_;}
end		{return END_;}
equatorial	{return EQUATORIAL_;}
erase		{return ERASE_;}
factor		{return FACTOR_;}
false		{return FALSE_;}
fast		{return FAST_;}
file		{return FILE_;}
fit		{return FIT_;}
fits		{return FITS_;}
fixed		{return FIXED_;}
fk4		{return FK4_;}
fk5		{return FK5_;}
flip		{return FLIP_;}
font		{return FONT_;}
front		{return FRONT_;}
full		{return FULL_;}
function	{return FUNCTION_;}
galactic	{return GALACTIC_;}
get		{return GET_;}
global		{return GLOBAL_;}
graphics	{return GRAPHICS_;}
gray		{return GRAY_;}
grid		{return GRID_;}
handle		{return HANDLE_;}
has		{return HAS_;}
header		{return HEADER_;}
height		{return HEIGHT_;}
hide		{return HIDE_;}
high		{return HIGH_;}
highlite	{return HIGHLITE_;}
histogram	{return HISTOGRAM_;}
horizontal	{return HORIZONTAL_;}
icrs		{return ICRS_;}
id		{return ID_;}
iis		{return IIS_;}
image		{return IMAGE_;}
include		{return INCLUDE_;}
info		{return INFO_;}
integer		{return INTEGER_;}
interpolate	{return INTERPOLATE_;}
irafmin		{return IRAFMIN_;}
j2000		{return J2000_;}
key		{return KEY_;}
level		{return LEVEL_;}
line		{return LINE_;}
linear		{return LINEAR_;}
list		{return LIST_;}
load		{return LOAD_;}
local		{return LOCAL_;}
log		{return LOG_;}
low		{return LOW_;}
magnifier	{return MAGNIFIER_;}
manual		{return MANUAL_;}
marker		{return MARKER_;}
master		{return MASTER_;}
message		{return MESSAGE_;}
minmax		{return MINMAX_;}
mmap		{return MMAP_;}
mode		{return MODE_;}
mosaic		{return MOSAIC_;}
motion		{return MOTION_;}
move		{return MOVE_;}
n		{return N_;}
nl		{return NL_;}
name		{return NAME_;}
names		{return NAMES_;}
new		{return NEW_;}
no		{return NO_;}
none		{return NONE_;}
number		{return NUMBER_;}
object		{return OBJECT_;}
off		{return OFF_;}
on		{return ON_;}
option		{return OPTION_;}
orient		{return ORIENT_;}
pan		{return PAN_;}
panner		{return PANNER_;}
param		{return PARAM_;}
paste		{return PASTE_;}
physical	{return PHYSICAL_;}
pixels		{return PIXELS_;}
point		{return POINT_;}
polygon		{return POLYGON_;}
postscript	{return POSTSCRIPT_;}
property	{return PROPERTY_;}
pros		{return PROS_;}
radius		{return RADIUS_;}
region		{return REGION_;}
reset		{return RESET_;}
resolution	{return RESOLUTION_;}
rgb		{return RGB_;}
rotate		{return ROTATE_;}
ruler		{return RULER_;}
sample		{return SAMPLE_;}
saoimage	{return SAOIMAGE_;}
saotng		{return SAOTNG_;}
save		{return SAVE_;}
scan		{return SCAN_;}
scientific	{return SCIENTIFIC_;}
scope		{return SCOPE_;}
segment		{return SEGMENT_;}
select		{return SELECT_;}
semicolon	{return SEMICOLON_;}
set		{return SET_;}
sexagesimal	{return SEXAGESIMAL_;}
shared		{return SHARED_;}
shift		{return SHIFT_;}
shmid		{return SHMID_;}
show		{return SHOW_;}
size		{return SIZE_;}
slave		{return SLAVE_;}
sqrt		{return SQRT_;}
square		{return SQUARE_;}
squared		{return SQUARED_;}
status		{return STATUS_;}
sum		{return SUM_;}
system		{return SYSTEM_;}
table		{return TABLE_;}
text		{return TEXT_;}
to		{return TO_;}
true		{return TRUE_;}
type		{return TYPE_;}
unselect 	{return UNSELECT_;}
unload		{return UNLOAD_;}
update		{return UPDATE_;}
use		{return USE_;}
user		{return USER_;}
value		{return VALUE_;}
version		{return VERSION_;}
vertex		{return VERTEX_;}
vertical	{return VERTICAL_;}
warp		{return WARP_;}
wcs		{return WCS_;}
width		{return WIDTH_;}
x		{return X_;}
xy		{return XY_;}
y		{return Y_;}
yes		{return YES_;}
zscale		{return ZSCALE_;}
zoom		{return ZOOM_;}

[+-]?{D}+	{ // Integer
		  frlval.integer = atoi(yytext);
		  sexSign = (yytext[0] == '-') ? -1 : 1;
		  return INT;
		}

[+-]?{D}+"."?({E})? |
[+-]?{D}*"."{D}+({E})? { // Real Number
		  frlval.real = atof(yytext);
		  return REAL;
		}

0[xX][0-9a-fA-F]+ { // Pointer
		  frlval.ptr = (void*)strtoul(yytext,NULL,16);
		  return POINTER;
		}

[+-]?{D}+"."?d |
[+-]?{D}*"."{D}+d { // degrees
		  yytext[yyleng-1] = '\0';
		  frlval.real = atof(yytext);
		  return DEGREE;
		}	

{D}+"."?' |
{D}*"."{D}+'	{ // minutes of arc
		  yytext[yyleng-1] = '\0';
		  frlval.real = atof(yytext);
		  return ARCMINUTE;
		}	

{D}+"."?\" |
{D}*"."{D}+\"	{ // seconds
		  yytext[yyleng-1] = '\0';
		  frlval.real = atof(yytext);
		  return ARCSECOND;
		}

[+-]?{D}+h	{ // hours
		  yytext[yyleng-1] = '\0';
		  frlval.integer = abs(atoi(yytext));
		  sexSign = (yytext[0] == '-') ? -1 : 1;
		  return HOUR;
		}	

{D}+m		{ // minutes
		  yytext[yyleng-1] = '\0';
		  frlval.integer = atoi(yytext);
		  return MINUTE;
		}	

{D}+"."?s |
{D}*"."{D}+s	{ // seconds
		  yytext[yyleng-1] = '\0';
		  frlval.real = atof(yytext);
		  return SECOND;
		}

[+-]?{D}+:{D}+:{D}+"."? |
[+-]?{D}+:{D}+:{D}*"."{D}+ { // sexagesimal
		  strcpy(frlval.str,yytext);
		  return SEXSTR;
		}	

{D}+"."?r |
{D}*"."{D}+r	{ // radians
		  yytext[yyleng-1] = '\0';
		  frlval.real = atof(yytext);
		  return RADIAN;
		}

{D}+p		{ // pixels
		  yytext[yyleng-1] = '\0';
		  frlval.integer = atoi(yytext);
		  return PIXEL;
		}

\"[^\"\n]*\" | 
\'[^\'\n]*\'	{ // Quoted String
		  strncpy(frlval.str,yytext+1,yyleng-2); // skip the " " 
	          frlval.str[yyleng-2] = '\0'; // Remove the '"' 
		  return STRING;
		}


[!-~][!-~]+	{ // General String-- at least 2 printable chars
		  strcpy(frlval.str,yytext);
		  return STRING;
		}

[ \t]+		{ // White Spaces
		} 

.		{ // Else, return the char
		  return yytext[0];
		}

%%

void frPassThru(int doit)
{
  if (frlexx)
    frlexx->begin(PASSTHRU, doit);
}

void frFlexLexer::begin(int which, int doit)
{
  BEGIN which;
  if (doit)
    yyless(0);
}
