#ifndef __polygon_h__
#define __polygon_h__

#include "marker.h"
#include "list.h"

class Polygon : public Marker {
private:
  List<Vertex>* vertex;
  double angle;
  Matrix flip;

  void render(Drawable, const Matrix&, GC);
  void moveVertex(const Vector&, int);

public:
  Polygon(Frame* p, const Vector& ctr, const Vector& bb, 
	  const char* clr,  const char* f, const char* t, unsigned short prop);
  Polygon(Frame* p, List<Vertex>*,
	  const char* clr,  const char* f, const char* t, unsigned short prop);
  ~Polygon();

  void updateBBox();
  void updateCoords(Matrix&);
  void draw();
  void drawXOR();
  void drawMagnifier(const Matrix&);
  void edit(const Vector&, int);
  void rotate(const Vector&, int);
  void ps(int);
  int isIn(const Vector& v);
  int isPolygon() {return 1;}

  double getAngle() {return angle;}
  void setAngle(double);

  void createVertex(int, const Vector&);
  void deleteVertex(int);
  int getSegment(const Vector&);

  void list(ostream&, int, int);
  void listSAOtng(ostream&, int, int);
  void listSAOimage(ostream&);
  void listPros(ostream&, int, int);
};

#endif
